Index: dll/shellext/shellbtrfs/propsheet.cpp
===================================================================
--- dll/shellext/shellbtrfs/propsheet.cpp	(révision 75772)
+++ dll/shellext/shellbtrfs/propsheet.cpp	(copie de travail)
@@ -1,17 +1,17 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
@@ -18,6 +18,7 @@
 #define ISOLATION_AWARE_ENABLED 1
 #define STRSAFE_NO_DEPRECATE
 
+#include "shellext.h"
 #ifndef __REACTOS__
 #include <windows.h>
 #include <strsafe.h>
@@ -28,6 +29,7 @@
 #include <winbase.h>
 #include <strsafe.h>
 #include <ndk/iofuncs.h>
+#include <ndk/iotypes.h>
 #endif
 
 #define NO_SHLWAPI_STRFCNS
@@ -37,40 +39,25 @@
 #include "propsheet.h"
 #include "resource.h"
 
-#ifndef __REACTOS__
-// FIXME - is there a way to link to the proper header files without breaking everything?
-#ifdef __cplusplus
-extern "C" {
-#endif
-NTSYSCALLAPI NTSTATUS NTAPI NtFsControlFile(HANDLE FileHandle, HANDLE Event, PIO_APC_ROUTINE ApcRoutine, PVOID ApcContext, PIO_STATUS_BLOCK IoStatusBlock, ULONG FsControlCode, PVOID InputBuffer, ULONG InputBufferLength, PVOID OutputBuffer, ULONG OutputBufferLength);
-#ifdef __cplusplus
-}
-#endif
+#define SUBVOL_ROOT_INODE 0x100
 
-#define STATUS_SUCCESS          (NTSTATUS)0x00000000
-#endif
+#ifndef __MINGW32__ // in winternl.h in mingw
 
-#define BTRFS_TYPE_FILE      1
-#define BTRFS_TYPE_DIRECTORY 2
-#define BTRFS_TYPE_CHARDEV   3
-#define BTRFS_TYPE_BLOCKDEV  4
-#define BTRFS_TYPE_FIFO      5
-#define BTRFS_TYPE_SOCKET    6
-#define BTRFS_TYPE_SYMLINK   7
+typedef struct _FILE_ACCESS_INFORMATION {
+    ACCESS_MASK AccessFlags;
+} FILE_ACCESS_INFORMATION, *PFILE_ACCESS_INFORMATION;
 
-extern HMODULE module;
+#define FileAccessInformation (FILE_INFORMATION_CLASS)8
 
-extern void ShowNtStatusError(HWND hwnd, NTSTATUS Status);
-static void format_size(UINT64 size, WCHAR* s, ULONG len);
-static void ShowError(HWND hwnd, ULONG err);
+#endif
 
 HRESULT __stdcall BtrfsPropSheet::QueryInterface(REFIID riid, void **ppObj) {
     if (riid == IID_IUnknown || riid == IID_IShellPropSheetExt) {
-        *ppObj = static_cast<IShellPropSheetExt*>(this); 
+        *ppObj = static_cast<IShellPropSheetExt*>(this);
         AddRef();
         return S_OK;
     } else if (riid == IID_IShellExtInit) {
-        *ppObj = static_cast<IShellExtInit*>(this); 
+        *ppObj = static_cast<IShellExtInit*>(this);
         AddRef();
         return S_OK;
     }
@@ -81,13 +68,13 @@
 
 void BtrfsPropSheet::add_to_search_list(WCHAR* fn) {
     WCHAR* s;
-    
+
     s = (WCHAR*)malloc((wcslen(fn) + 1) * sizeof(WCHAR));
     if (!s)
         return;
-    
+
     memcpy(s, fn, (wcslen(fn) + 1) * sizeof(WCHAR));
-    
+
     search_list.push_back(s);
 }
 
@@ -95,42 +82,42 @@
     HANDLE h;
     WCHAR* ss;
     WIN32_FIND_DATAW ffd;
-    
+
     ss = (WCHAR*)malloc((wcslen(fn) + 3) * sizeof(WCHAR));
     if (!ss)
         return;
-    
+
     memcpy(ss, fn, (wcslen(fn) + 1) * sizeof(WCHAR));
     wcscat(ss, L"\\*");
-    
+
     h = FindFirstFileW(ss, &ffd);
     if (h == INVALID_HANDLE_VALUE)
         return;
-    
+
     do {
         if (ffd.cFileName[0] != '.' || ((ffd.cFileName[1] != 0) && (ffd.cFileName[1] != '.' || ffd.cFileName[2] != 0))) {
             WCHAR* fn2 = (WCHAR*)malloc((wcslen(fn) + 1 + wcslen(ffd.cFileName) + 1) * sizeof(WCHAR));
-                
+
             memcpy(fn2, fn, (wcslen(fn) + 1) * sizeof(WCHAR));
             wcscat(fn2, L"\\");
             wcscat(fn2, ffd.cFileName);
-            
+
             if (ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
                 add_to_search_list(fn2);
             } else {
                 HANDLE fh;
-                
+
                 fh = CreateFileW(fn2, FILE_TRAVERSE | FILE_READ_ATTRIBUTES, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL,
                                  OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_OPEN_REPARSE_POINT, NULL);
-                
+
                 if (fh != INVALID_HANDLE_VALUE) {
                     NTSTATUS Status;
                     IO_STATUS_BLOCK iosb;
                     btrfs_inode_info bii2;
-                    
+
                     Status = NtFsControlFile(fh, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_GET_INODE_INFO, NULL, 0, &bii2, sizeof(btrfs_inode_info));
-                
-                    if (Status == STATUS_SUCCESS) {
+
+                    if (NT_SUCCESS(Status)) {
                         sizes[0] += bii2.inline_length;
                         sizes[1] += bii2.disk_size[0];
                         sizes[2] += bii2.disk_size[1];
@@ -137,15 +124,15 @@
                         sizes[3] += bii2.disk_size[2];
                         totalsize += bii2.inline_length + bii2.disk_size[0] + bii2.disk_size[1] + bii2.disk_size[2];
                     }
-                    
+
                     CloseHandle(fh);
                 }
-                
+
                 free(fn2);
             }
         }
     } while (FindNextFileW(h, &ffd));
-    
+
     FindClose(h);
 }
 
@@ -152,233 +139,372 @@
 DWORD BtrfsPropSheet::search_list_thread() {
     while (!search_list.empty()) {
         WCHAR* fn = search_list.front();
-        
+
         do_search(fn);
-        
+
         search_list.pop_front();
         free(fn);
     }
-    
+
     thread = NULL;
-    
+
     return 0;
 }
 
 static DWORD WINAPI global_search_list_thread(LPVOID lpParameter) {
     BtrfsPropSheet* bps = (BtrfsPropSheet*)lpParameter;
-    
+
     return bps->search_list_thread();
 }
 
-HRESULT __stdcall BtrfsPropSheet::Initialize(PCIDLIST_ABSOLUTE pidlFolder, IDataObject* pdtobj, HKEY hkeyProgID) {
+HRESULT BtrfsPropSheet::check_file(std::wstring fn, UINT i, UINT num_files, UINT* sv) {
     HANDLE h;
     IO_STATUS_BLOCK iosb;
     NTSTATUS Status;
+    FILE_ACCESS_INFORMATION fai;
+    BY_HANDLE_FILE_INFORMATION bhfi;
+    btrfs_inode_info bii2;
+
+    h = CreateFileW(fn.c_str(), MAXIMUM_ALLOWED, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL,
+                    OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_OPEN_REPARSE_POINT, NULL);
+
+    if (h == INVALID_HANDLE_VALUE)
+        return E_FAIL;
+
+    Status = NtQueryInformationFile(h, &iosb, &fai, sizeof(FILE_ACCESS_INFORMATION), FileAccessInformation);
+    if (!NT_SUCCESS(Status)) {
+        CloseHandle(h);
+        return E_FAIL;
+    }
+
+    if (fai.AccessFlags & FILE_READ_ATTRIBUTES)
+        can_change_perms = fai.AccessFlags & WRITE_DAC;
+
+    readonly = !(fai.AccessFlags & FILE_WRITE_ATTRIBUTES);
+
+    if (!readonly && num_files == 1 && !can_change_perms)
+        show_admin_button = TRUE;
+
+    if (GetFileInformationByHandle(h, &bhfi) && bhfi.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
+        add_to_search_list((WCHAR*)fn.c_str());
+
+    Status = NtFsControlFile(h, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_GET_INODE_INFO, NULL, 0, &bii2, sizeof(btrfs_inode_info));
+
+    if (NT_SUCCESS(Status) && !bii2.top) {
+        int j;
+
+        LARGE_INTEGER filesize;
+
+        if (i == 0) {
+            subvol = bii2.subvol;
+            inode = bii2.inode;
+            type = bii2.type;
+            uid = bii2.st_uid;
+            gid = bii2.st_gid;
+            rdev = bii2.st_rdev;
+        } else {
+            if (subvol != bii2.subvol)
+                various_subvols = TRUE;
+
+            if (inode != bii2.inode)
+                various_inodes = TRUE;
+
+            if (type != bii2.type)
+                various_types = TRUE;
+
+            if (uid != bii2.st_uid)
+                various_uids = TRUE;
+
+            if (gid != bii2.st_gid)
+                various_gids = TRUE;
+        }
+
+        if (bii2.inline_length > 0) {
+            totalsize += bii2.inline_length;
+            sizes[0] += bii2.inline_length;
+        }
+
+        for (j = 0; j < 3; j++) {
+            if (bii2.disk_size[j] > 0) {
+                totalsize += bii2.disk_size[j];
+                sizes[j + 1] += bii2.disk_size[j];
+            }
+        }
+
+        min_mode |= ~bii2.st_mode;
+        max_mode |= bii2.st_mode;
+        min_flags |= ~bii2.flags;
+        max_flags |= bii2.flags;
+        min_compression_type = bii2.compression_type < min_compression_type ? bii2.compression_type : min_compression_type;
+        max_compression_type = bii2.compression_type > max_compression_type ? bii2.compression_type : max_compression_type;
+
+        if (bii2.inode == SUBVOL_ROOT_INODE) {
+            BOOL ro = bhfi.dwFileAttributes & FILE_ATTRIBUTE_READONLY;
+
+            has_subvols = TRUE;
+
+            if (*sv == 0)
+                ro_subvol = ro;
+            else {
+                if (ro_subvol != ro)
+                    various_ro = TRUE;
+            }
+
+            (*sv)++;
+        }
+
+        ignore = FALSE;
+
+        if (bii2.type != BTRFS_TYPE_DIRECTORY && GetFileSizeEx(h, &filesize)) {
+            if (filesize.QuadPart != 0)
+                can_change_nocow = FALSE;
+        }
+
+        CloseHandle(h);
+    } else {
+        CloseHandle(h);
+        return E_FAIL;
+    }
+
+    return S_OK;
+}
+
+HRESULT BtrfsPropSheet::load_file_list() {
+    UINT num_files, i, sv = 0;
+    WCHAR fn[MAX_PATH];
+
+    num_files = DragQueryFileW((HDROP)stgm.hGlobal, 0xFFFFFFFF, NULL, 0);
+
+    min_mode = 0;
+    max_mode = 0;
+    min_flags = 0;
+    max_flags = 0;
+    min_compression_type = 0xff;
+    max_compression_type = 0;
+    various_subvols = various_inodes = various_types = various_uids = various_gids = various_ro = FALSE;
+
+    can_change_perms = TRUE;
+    can_change_nocow = TRUE;
+
+    sizes[0] = sizes[1] = sizes[2] = sizes[3] = 0;
+
+    for (i = 0; i < num_files; i++) {
+        if (DragQueryFileW((HDROP)stgm.hGlobal, i, fn, sizeof(fn) / sizeof(MAX_PATH))) {
+            HRESULT hr;
+
+            hr = check_file(fn, i, num_files, &sv);
+            if (FAILED(hr))
+                return hr;
+        } else
+            return E_FAIL;
+    }
+
+    min_mode = ~min_mode;
+    min_flags = ~min_flags;
+
+    mode = min_mode;
+    mode_set = ~(min_mode ^ max_mode);
+
+    flags = min_flags;
+    flags_set = ~(min_flags ^ max_flags);
+
+    return S_OK;
+}
+
+HRESULT __stdcall BtrfsPropSheet::Initialize(PCIDLIST_ABSOLUTE pidlFolder, IDataObject* pdtobj, HKEY hkeyProgID) {
     FORMATETC format = { CF_HDROP, NULL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };
-    UINT num_files, i;
-    WCHAR fn[MAX_PATH];
     HDROP hdrop;
-    
+    HRESULT hr;
+
     if (pidlFolder)
         return E_FAIL;
-        
-    
+
     if (!pdtobj)
         return E_FAIL;
-    
+
     stgm.tymed = TYMED_HGLOBAL;
-    
+
     if (FAILED(pdtobj->GetData(&format, &stgm)))
         return E_INVALIDARG;
-    
+
     stgm_set = TRUE;
-    
+
     hdrop = (HDROP)GlobalLock(stgm.hGlobal);
-    
+
     if (!hdrop) {
         ReleaseStgMedium(&stgm);
         stgm_set = FALSE;
         return E_INVALIDARG;
     }
-        
-    num_files = DragQueryFileW((HDROP)stgm.hGlobal, 0xFFFFFFFF, NULL, 0);
-    
+
+    hr = load_file_list();
+    if (FAILED(hr))
+        return hr;
+
+    if (search_list.size() > 0) {
+        thread = CreateThread(NULL, 0, global_search_list_thread, this, 0, NULL);
+
+        if (!thread)
+            ShowError(NULL, GetLastError());
+    }
+
+    GlobalUnlock(hdrop);
+
+    return S_OK;
+}
+
+void BtrfsPropSheet::set_cmdline(std::wstring cmdline) {
+    HANDLE h;
+    IO_STATUS_BLOCK iosb;
+    NTSTATUS Status;
+    UINT sv = 0;
+    BY_HANDLE_FILE_INFORMATION bhfi;
+    btrfs_inode_info bii2;
+    FILE_ACCESS_INFORMATION fai;
+
     min_mode = 0;
     max_mode = 0;
     min_flags = 0;
     max_flags = 0;
-    various_subvols = various_inodes = various_types = various_uids = various_gids = FALSE;
-    
+    min_compression_type = 0xff;
+    max_compression_type = 0;
+    various_subvols = various_inodes = various_types = various_uids = various_gids = various_ro = FALSE;
+
     can_change_perms = TRUE;
-    can_change_owner = TRUE;
     can_change_nocow = TRUE;
-    
-    for (i = 0; i < num_files; i++) {
-        if (DragQueryFileW((HDROP)stgm.hGlobal, i, fn, sizeof(fn) / sizeof(MAX_PATH))) {
-            h = CreateFileW(fn, FILE_TRAVERSE | FILE_READ_ATTRIBUTES | WRITE_DAC, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL,
-                            OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_OPEN_REPARSE_POINT, NULL);
-            
-            if (h != INVALID_HANDLE_VALUE)
-                CloseHandle(h);
-            else
-                can_change_perms = FALSE;
-            
-            h = CreateFileW(fn, FILE_TRAVERSE | FILE_READ_ATTRIBUTES | WRITE_OWNER, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL,
-                            OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_OPEN_REPARSE_POINT, NULL);
-            
-            if (h != INVALID_HANDLE_VALUE)
-                CloseHandle(h);
-            else
-                can_change_owner = FALSE;
-            
-            h = CreateFileW(fn, FILE_TRAVERSE | FILE_READ_ATTRIBUTES | FILE_WRITE_ATTRIBUTES, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL,
-                            OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_OPEN_REPARSE_POINT, NULL);
 
-            if (h == INVALID_HANDLE_VALUE && (GetLastError() == ERROR_ACCESS_DENIED || GetLastError() == ERROR_WRITE_PROTECT)) {
-                h = CreateFileW(fn, FILE_TRAVERSE | FILE_READ_ATTRIBUTES, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL, OPEN_EXISTING,
-                                FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_OPEN_REPARSE_POINT, NULL);
-                
-                readonly = TRUE;
+    h = CreateFileW(cmdline.c_str(), MAXIMUM_ALLOWED, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL,
+                    OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_OPEN_REPARSE_POINT, NULL);
+
+    if (h == INVALID_HANDLE_VALUE)
+        return;
+
+    Status = NtQueryInformationFile(h, &iosb, &fai, sizeof(FILE_ACCESS_INFORMATION), FileAccessInformation);
+    if (!NT_SUCCESS(Status)) {
+        CloseHandle(h);
+        return;
+    }
+
+    if (fai.AccessFlags & FILE_READ_ATTRIBUTES)
+        can_change_perms = fai.AccessFlags & WRITE_DAC;
+
+    readonly = !(fai.AccessFlags & FILE_WRITE_ATTRIBUTES);
+
+    if (GetFileInformationByHandle(h, &bhfi) && bhfi.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
+        add_to_search_list((WCHAR*)cmdline.c_str());
+
+    Status = NtFsControlFile(h, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_GET_INODE_INFO, NULL, 0, &bii2, sizeof(btrfs_inode_info));
+
+    if (NT_SUCCESS(Status) && !bii2.top) {
+        int j;
+
+        LARGE_INTEGER filesize;
+
+        subvol = bii2.subvol;
+        inode = bii2.inode;
+        type = bii2.type;
+        uid = bii2.st_uid;
+        gid = bii2.st_gid;
+        rdev = bii2.st_rdev;
+
+        if (bii2.inline_length > 0) {
+            totalsize += bii2.inline_length;
+            sizes[0] += bii2.inline_length;
+        }
+
+        for (j = 0; j < 3; j++) {
+            if (bii2.disk_size[j] > 0) {
+                totalsize += bii2.disk_size[j];
+                sizes[j + 1] += bii2.disk_size[j];
             }
-            
-            if (h != INVALID_HANDLE_VALUE) {
-                BY_HANDLE_FILE_INFORMATION bhfi;
-                btrfs_inode_info bii2;
-                
-                if (GetFileInformationByHandle(h, &bhfi) && bhfi.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
-                    add_to_search_list(fn);
-                
-                Status = NtFsControlFile(h, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_GET_INODE_INFO, NULL, 0, &bii2, sizeof(btrfs_inode_info));
-                    
-                if (Status == STATUS_SUCCESS && !bii2.top) {
-                    int j;
-                    
-                    LARGE_INTEGER filesize;
-                    
-                    if (i == 0) {
-                        subvol = bii2.subvol;
-                        inode = bii2.inode;
-                        type = bii2.type;
-                        uid = bii2.st_uid;
-                        gid = bii2.st_gid;
-                        rdev = bii2.st_rdev;
-                    } else {
-                        if (subvol != bii2.subvol)
-                            various_subvols = TRUE;
-                        
-                        if (inode != bii2.inode)
-                            various_inodes = TRUE;
-                        
-                        if (type != bii2.type)
-                            various_types = TRUE;
-                        
-                        if (uid != bii2.st_uid)
-                            various_uids = TRUE;
+        }
 
-                        if (gid != bii2.st_gid)
-                            various_gids = TRUE;
-                    }
+        min_mode |= ~bii2.st_mode;
+        max_mode |= bii2.st_mode;
+        min_flags |= ~bii2.flags;
+        max_flags |= bii2.flags;
+        min_compression_type = bii2.compression_type < min_compression_type ? bii2.compression_type : min_compression_type;
+        max_compression_type = bii2.compression_type > max_compression_type ? bii2.compression_type : max_compression_type;
 
-                    if (bii2.inline_length > 0) {
-                        totalsize += bii2.inline_length;
-                        sizes[0] += bii2.inline_length;
-                    }
-                    
-                    for (j = 0; j < 3; j++) {
-                        if (bii2.disk_size[j] > 0) {
-                            totalsize += bii2.disk_size[j];
-                            sizes[j + 1] += bii2.disk_size[j];
-                        }
-                    }
-                    
-                    min_mode |= ~bii2.st_mode;
-                    max_mode |= bii2.st_mode;
-                    min_flags |= ~bii2.flags;
-                    max_flags |= bii2.flags;
-                    
-                    ignore = FALSE;
-                    
-                    if (bii2.type != BTRFS_TYPE_DIRECTORY && GetFileSizeEx(h, &filesize)) {
-                        if (filesize.QuadPart != 0)
-                            can_change_nocow = FALSE;
-                    }
-                    
-                    CloseHandle(h);
-                } else {
-                    CloseHandle(h);
-                    return E_FAIL;
-                }
-            } else
-                return E_FAIL;
-        } else
-            return E_FAIL;
+        if (bii2.inode == SUBVOL_ROOT_INODE) {
+            BOOL ro = bhfi.dwFileAttributes & FILE_ATTRIBUTE_READONLY;
+
+            has_subvols = TRUE;
+
+            if (sv == 0)
+                ro_subvol = ro;
+            else {
+                if (ro_subvol != ro)
+                    various_ro = TRUE;
+            }
+
+            sv++;
+        }
+
+        ignore = FALSE;
+
+        if (bii2.type != BTRFS_TYPE_DIRECTORY && GetFileSizeEx(h, &filesize)) {
+            if (filesize.QuadPart != 0)
+                can_change_nocow = FALSE;
+        }
+
+        CloseHandle(h);
+    } else {
+        CloseHandle(h);
+        return;
     }
-    
+
     min_mode = ~min_mode;
     min_flags = ~min_flags;
-    
+
     mode = min_mode;
     mode_set = ~(min_mode ^ max_mode);
-    
+
     flags = min_flags;
     flags_set = ~(min_flags ^ max_flags);
-    
+
     if (search_list.size() > 0) {
         thread = CreateThread(NULL, 0, global_search_list_thread, this, 0, NULL);
-        
+
         if (!thread)
             ShowError(NULL, GetLastError());
     }
 
-    return S_OK;
+    this->filename = cmdline;
 }
 
 static ULONG inode_type_to_string_ref(UINT8 type) {
-    switch (type) {    
+    switch (type) {
         case BTRFS_TYPE_FILE:
             return IDS_INODE_FILE;
-        
+
         case BTRFS_TYPE_DIRECTORY:
             return IDS_INODE_DIR;
-            
+
         case BTRFS_TYPE_CHARDEV:
             return IDS_INODE_CHAR;
-            
+
         case BTRFS_TYPE_BLOCKDEV:
             return IDS_INODE_BLOCK;
-            
+
         case BTRFS_TYPE_FIFO:
             return IDS_INODE_FIFO;
-            
+
         case BTRFS_TYPE_SOCKET:
             return IDS_INODE_SOCKET;
-            
+
         case BTRFS_TYPE_SYMLINK:
             return IDS_INODE_SYMLINK;
-            
+
         default:
             return IDS_INODE_UNKNOWN;
     }
 }
 
-static void ShowError(HWND hwnd, ULONG err) {
-    WCHAR* buf;
-    
-    if (FormatMessageW(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL,
-                       err, 0, (WCHAR*)&buf, 0, NULL) == 0) {
-        MessageBoxW(hwnd, L"FormatMessage failed", L"Error", MB_ICONERROR);
-        return;
-    }
-    
-    MessageBoxW(hwnd, buf, L"Error", MB_ICONERROR);
-    
-    LocalFree(buf);
-}
-
 void BtrfsPropSheet::change_inode_flag(HWND hDlg, UINT64 flag, UINT state) {
     if (flag & BTRFS_INODE_NODATACOW)
         flag |= BTRFS_INODE_NODATASUM;
-    
+
     if (state == BST_CHECKED) {
         flags |= flag;
         flags_set |= flag;
@@ -388,123 +514,153 @@
     } else if (state == BST_INDETERMINATE) {
         flags_set = ~flag;
     }
-    
+
     flags_changed = TRUE;
-    
-    SendMessageW(GetParent(hDlg), PSM_CHANGED, 0, 0);
+
+    SendMessageW(GetParent(hDlg), PSM_CHANGED, (WPARAM)hDlg, 0);
 }
 
-void BtrfsPropSheet::apply_changes(HWND hDlg) {
-    UINT num_files, i;
-    WCHAR fn[MAX_PATH]; // FIXME - is this long enough?
+void BtrfsPropSheet::apply_changes_file(HWND hDlg, std::wstring fn) {
     HANDLE h;
     IO_STATUS_BLOCK iosb;
     NTSTATUS Status;
     btrfs_set_inode_info bsii;
-    
+    btrfs_inode_info bii2;
+    ULONG perms = FILE_TRAVERSE | FILE_READ_ATTRIBUTES;
+
+    if (flags_changed || ro_changed)
+        perms |= FILE_WRITE_ATTRIBUTES;
+
+    if (perms_changed || gid_changed || uid_changed)
+        perms |= WRITE_DAC;
+
+    if (mode_set & S_ISUID && (((min_mode & S_ISUID) != (max_mode & S_ISUID)) || ((min_mode & S_ISUID) != (mode & S_ISUID))))
+        perms |= WRITE_OWNER;
+
+    h = CreateFileW(fn.c_str(), perms, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL,
+                    OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_OPEN_REPARSE_POINT, NULL);
+
+    if (h == INVALID_HANDLE_VALUE) {
+        ShowError(hDlg, GetLastError());
+        return;
+    }
+
+    ZeroMemory(&bsii, sizeof(btrfs_set_inode_info));
+
+    Status = NtFsControlFile(h, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_GET_INODE_INFO, NULL, 0, &bii2, sizeof(btrfs_inode_info));
+
+    if (!NT_SUCCESS(Status)) {
+        ShowNtStatusError(hDlg, Status);
+        CloseHandle(h);
+        return;
+    }
+
+    if (bii2.inode == SUBVOL_ROOT_INODE && ro_changed) {
+        BY_HANDLE_FILE_INFORMATION bhfi;
+        FILE_BASIC_INFO fbi;
+
+        if (!GetFileInformationByHandle(h, &bhfi)) {
+            ShowError(hDlg, GetLastError());
+            return;
+        }
+
+        memset(&fbi, 0, sizeof(fbi));
+        fbi.FileAttributes = bhfi.dwFileAttributes;
+
+        if (ro_subvol)
+            fbi.FileAttributes |= FILE_ATTRIBUTE_READONLY;
+        else
+            fbi.FileAttributes &= ~FILE_ATTRIBUTE_READONLY;
+
+        if (!SetFileInformationByHandle(h, FileBasicInfo, &fbi, sizeof(fbi))) {
+            CloseHandle(h);
+            ShowError(hDlg, GetLastError());
+            return;
+        }
+    }
+
+    if (flags_changed || perms_changed || uid_changed || gid_changed || compress_type_changed) {
+        if (flags_changed) {
+            bsii.flags_changed = TRUE;
+            bsii.flags = (bii2.flags & ~flags_set) | (flags & flags_set);
+        }
+
+        if (perms_changed) {
+            bsii.mode_changed = TRUE;
+            bsii.st_mode = (bii2.st_mode & ~mode_set) | (mode & mode_set);
+        }
+
+        if (uid_changed) {
+            bsii.uid_changed = TRUE;
+            bsii.st_uid = uid;
+        }
+
+        if (gid_changed) {
+            bsii.gid_changed = TRUE;
+            bsii.st_gid = gid;
+        }
+
+        if (compress_type_changed) {
+            bsii.compression_type_changed = TRUE;
+            bsii.compression_type = compress_type;
+        }
+
+        Status = NtFsControlFile(h, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_SET_INODE_INFO, &bsii, sizeof(btrfs_set_inode_info), NULL, 0);
+
+        if (!NT_SUCCESS(Status)) {
+            ShowNtStatusError(hDlg, Status);
+            CloseHandle(h);
+            return;
+        }
+    }
+
+    CloseHandle(h);
+}
+
+void BtrfsPropSheet::apply_changes(HWND hDlg) {
+    UINT num_files, i;
+    WCHAR fn[MAX_PATH]; // FIXME - is this long enough?
+
     if (various_uids)
         uid_changed = FALSE;
-    
+
     if (various_gids)
         gid_changed = FALSE;
-    
-    if (!flags_changed && !perms_changed && !uid_changed && !gid_changed)
+
+    if (!flags_changed && !perms_changed && !uid_changed && !gid_changed && !compress_type_changed && !ro_changed)
         return;
 
-    num_files = DragQueryFileW((HDROP)stgm.hGlobal, 0xFFFFFFFF, NULL, 0);
-    
-    for (i = 0; i < num_files; i++) {
-        if (DragQueryFileW((HDROP)stgm.hGlobal, i, fn, sizeof(fn) / sizeof(MAX_PATH))) {
-            ULONG perms = FILE_TRAVERSE | FILE_READ_ATTRIBUTES;
-            
-            if (flags_changed)
-                perms |= FILE_WRITE_ATTRIBUTES;
-            
-            if (perms_changed)
-                perms |= WRITE_DAC;
-            
-            if (uid_changed || gid_changed)
-                perms |= WRITE_OWNER;
-            
-            h = CreateFileW(fn, perms, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL,
-                            OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_OPEN_REPARSE_POINT, NULL);
+    if (filename[0] != 0)
+        apply_changes_file(hDlg, filename);
+    else {
+        num_files = DragQueryFileW((HDROP)stgm.hGlobal, 0xFFFFFFFF, NULL, 0);
 
-            if (h == INVALID_HANDLE_VALUE) {
-                ShowError(hDlg, GetLastError());
-                return;
+        for (i = 0; i < num_files; i++) {
+            if (DragQueryFileW((HDROP)stgm.hGlobal, i, fn, sizeof(fn) / sizeof(MAX_PATH))) {
+                apply_changes_file(hDlg, fn);
             }
-            
-            ZeroMemory(&bsii, sizeof(btrfs_set_inode_info));
-            
-            btrfs_inode_info bii2;
-                    
-            Status = NtFsControlFile(h, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_GET_INODE_INFO, NULL, 0, &bii2, sizeof(btrfs_inode_info));
-        
-            if (Status != STATUS_SUCCESS) {
-                ShowNtStatusError(hDlg, Status);
-                CloseHandle(h);
-                return;
-            }
-            
-            if (flags_changed) {
-                bsii.flags_changed = TRUE;
-                bsii.flags = (bii2.flags & ~flags_set) | (flags & flags_set);
-            }
-            
-            if (perms_changed) {
-                bsii.mode_changed = TRUE;
-                bsii.st_mode = (bii2.st_mode & ~mode_set) | (mode & mode_set);
-            }
-            
-            if (uid_changed) {
-                bsii.uid_changed = TRUE;
-                bsii.st_uid = uid;
-            }
-            
-            if (gid_changed) {
-                bsii.gid_changed = TRUE;
-                bsii.st_gid = gid;
-            }
-            
-            Status = NtFsControlFile(h, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_SET_INODE_INFO, NULL, 0, &bsii, sizeof(btrfs_set_inode_info));
-            CloseHandle(h);
-
-            if (Status != STATUS_SUCCESS) {
-                WCHAR s[255], t[255];
-                
-                if (!LoadStringW(module, IDS_SET_INODE_INFO_ERROR, t, sizeof(t) / sizeof(WCHAR))) {
-                    ShowError(hDlg, GetLastError());
-                    return;
-                }
-                
-                if (StringCchPrintfW(s, sizeof(s) / sizeof(WCHAR), t, Status) == STRSAFE_E_INSUFFICIENT_BUFFER) {
-                    ShowError(hDlg, ERROR_INSUFFICIENT_BUFFER);
-                    return;
-                }
-                
-                MessageBoxW(hDlg, s, L"Error", MB_ICONERROR);
-            }
         }
     }
-    
+
     flags_changed = FALSE;
     perms_changed = FALSE;
     uid_changed = FALSE;
     gid_changed = FALSE;
+    ro_changed = FALSE;
 }
 
 void BtrfsPropSheet::set_size_on_disk(HWND hwndDlg) {
     WCHAR size_on_disk[1024], s[1024], old_text[1024];
-    
-    format_size(totalsize, size_on_disk, sizeof(size_on_disk) / sizeof(WCHAR));
-    
+
+    format_size(totalsize, size_on_disk, sizeof(size_on_disk) / sizeof(WCHAR), TRUE);
+
     if (StringCchPrintfW(s, sizeof(s) / sizeof(WCHAR), size_format, size_on_disk) == STRSAFE_E_INSUFFICIENT_BUFFER) {
         ShowError(hwndDlg, ERROR_INSUFFICIENT_BUFFER);
         return;
     }
-    
+
     GetDlgItemTextW(hwndDlg, IDC_SIZE_ON_DISK, old_text, sizeof(old_text) / sizeof(WCHAR));
-    
+
     if (wcscmp(s, old_text))
         SetDlgItemTextW(hwndDlg, IDC_SIZE_ON_DISK, s);
 }
@@ -519,26 +675,28 @@
     } else if (state == BST_INDETERMINATE) {
         mode_set = ~flag;
     }
-    
+
     perms_changed = TRUE;
-    
-    SendMessageW(GetParent(hDlg), PSM_CHANGED, 0, 0);
+
+    SendMessageW(GetParent(hDlg), PSM_CHANGED, (WPARAM)hDlg, 0);
 }
 
 void BtrfsPropSheet::change_uid(HWND hDlg, UINT32 uid) {
-    this->uid = uid;
-    
-    uid_changed = TRUE;
-    
-    SendMessageW(GetParent(hDlg), PSM_CHANGED, 0, 0);
+    if (this->uid != uid) {
+        this->uid = uid;
+        uid_changed = TRUE;
+
+        SendMessageW(GetParent(hDlg), PSM_CHANGED, (WPARAM)hDlg, 0);
+    }
 }
 
 void BtrfsPropSheet::change_gid(HWND hDlg, UINT32 gid) {
-    this->gid = gid;
-    
-    gid_changed = TRUE;
-    
-    SendMessageW(GetParent(hDlg), PSM_CHANGED, 0, 0);
+    if (this->gid != gid) {
+        this->gid = gid;
+        gid_changed = TRUE;
+
+        SendMessageW(GetParent(hDlg), PSM_CHANGED, (WPARAM)hDlg, 0);
+    }
 }
 
 void BtrfsPropSheet::update_size_details_dialog(HWND hDlg) {
@@ -545,12 +703,12 @@
     WCHAR size[1024], old_text[1024];
     int i;
     ULONG items[] = { IDC_SIZE_INLINE, IDC_SIZE_UNCOMPRESSED, IDC_SIZE_ZLIB, IDC_SIZE_LZO };
-    
+
     for (i = 0; i < 4; i++) {
-        format_size(sizes[i], size, sizeof(size) / sizeof(WCHAR));
-        
+        format_size(sizes[i], size, sizeof(size) / sizeof(WCHAR), TRUE);
+
         GetDlgItemTextW(hDlg, items[i], old_text, sizeof(old_text) / sizeof(WCHAR));
-        
+
         if (wcscmp(size, old_text))
             SetDlgItemTextW(hDlg, items[i], size);
     }
